
var g_sound_on = true;
var g_max_sounds  = 16;
var g_sound_array = new Array(g_max_sounds);
var g_current_sound = 0;
var g_music_on = true;
var g_max_music   = 1;
var g_music_array = new Array(g_max_music);
var g_current_music = 0;
var g_music_volume = 150;
var g_sound_volume = 200;

function PlaySound(filename) {
  if (g_current_sound > g_max_sounds)
    g_current_sound = 0;

  var repeat = false;
  if (g_sound_on) {
    if (DoesSoundExist(filename)) {
      g_sound_array[g_current_sound] = LoadSound(filename);
      g_sound_array[g_current_sound].setVolume(GetSoundVolume());
      g_sound_array[g_current_sound].play(repeat);
      g_current_sound += 1;
    }
  }
}

function PlayMusic(filename) { // like ChangeMusic but supports having more than one music
  if (g_current_music > g_max_music)
    g_current_music = 0;

  var repeat = true;
  if (g_music_on) {
    if (DoesSoundExist(filename)) {
      g_music_array[g_current_music] = LoadSound(filename);
      g_music_array[g_current_music].setVolume(GetMusicVolume());
      g_music_array[g_current_music].play(repeat);
      g_current_music += 1;
    }
  }
}

function TurnOnSounds() {
  g_sounds_on = true;
}

function TurnOnMusic() {
  g_music_on = true;
}

function TurnOffSounds() {
  for (var i = 0; i < g_max_sounds; ++i)
    if(g_sound_array)
      g_sound_array[i].stop();
  g_current_music = 0;
  g_sounds_on = false;
}

function TurnOffMusic() {
  for (var i = 0; i < g_max_music; ++i)
    if(g_music_array)
      g_music_array[i].stop();
  g_current_music = 0;
  g_music_on = false;
}

function GetSoundVolume() {
  return g_sound_volume;
}

function SetSoundVolume(volume) {
  for (var i = 0; i < g_sound_array.length; ++i)
    if (g_sound_array[i])
      g_sound_array[i].setVolume(volume);
  g_sound_volume = volume;
}

function GetMusicVolume() {
  return g_music_volume;
}

function SetMusicVolume(volume) {
  for (var i = 0; i < g_music_array.length; ++i)
    if (g_music_array[i])
      g_music_array[i].setVolume(volume);
  g_music_volume = volume;
}


function GetSoundList() {
  var list = GetFileList("sounds");
  return list;
}

function DoesSoundExist(filename) {
  var list = GetSoundList();
  for (var i = 0; i < list.length; ++i)
    if (list[i] == filename)
      return true;
  return false;
}