function OnEnterMap() {
  switch(GetCurrentMap()) {
    
  }
  PlayMusic(GetMusicForMap());
}

function OnLeaveMap() {
  switch(GetCurrentMap()) {
    
  }
  GeneralMapSwitch();
}

function GetMusicForMap() {
  var filename = "";
  switch(GetCurrentMap()) {
    case ("beach.rmp"): filename = "blank.wav"; break;
  }
  return filename;
}

//////////////////////////////////////

function GeneralMapSwitch() {
  gMapTextArray = new Array();
}

function MapSwitch(loop_horizontally, loop_vertically, block_horizontally, block_vertically, filename, person, x, y) {

  if (filename != "") {
    ChangeMap(filename);
  }

  if (block_horizontally)
    SetPersonX(person, x)

  if (block_vertically)
    SetPersonY(person, y);

  if (loop_horizontally)
  {
    if (x < GetMapWidth() / 2)
      SetPersonX(person, GetMapWidth() - 1);
    else
      SetPersonX(person, 1);
  }

  if (loop_vertically) {
    if (y < GetMapHeight() / 2)
      SetPersonY(person, GetMapHeight() - 1);
    else
      SetPersonY(person, 1);
  }

  if (IsCameraAttached()) {
    var camera_person = GetCameraPerson()
    DetachCamera();
    SetCameraX(GetScreenWidth() / 2);
    SetCameraY(GetScreenHeight() / 2);
    AttachCamera(camera_person);
  } 

}

function GetMapSwitchDetails(direction) {
  var msd = new Object();

  msd.filename = "";
  msd.person = GetInputPerson();
  msd.x = GetPersonX(msd.person);
  msd.y = GetPersonY(msd.person);
  msd.block_horizontally = true;
  msd.block_vertically = true;

  switch (direction) {
    case "north":
      msd.loop_horizontally = false;
      msd.loop_vertically = true;
    break;

    case ("east"):
      msd.loop_horizontally = true;
      msd.loop_vertically = false;
    break;

    case ("south"):
      msd.loop_horizontally = false;
      msd.loop_vertically = true;
    break;

    case ("west"):
      msd.loop_horizontally = true;
      msd.loop_vertically = false;
    break;
  }
  return msd;
}

function OnLeaveMapNorth() {
  var map_switch_details = GetMapSwitchDetails("north");

  with (map_switch_details) {
    switch(GetCurrentMap()) {
      case ("beach.rmp"): filename = "forest path.rmp"; break;
      case ("forest path.rmp"): filename = "forest house.rmp"; break;
      case ("graveyard.rmp"): filename = "treehouse.rmp"; break;
      case ("cave inside.rmp"): filename = "church.rmp"; break;
      case ("cave.rmp"): filename = "cave inside.rmp"; break;
    }

    MapSwitch(loop_horizontally, loop_vertically, block_horizontally, block_vertically, filename, person, x, y);
  }
}

function OnLeaveMapEast() {
  var map_switch_details = GetMapSwitchDetails("east");

  with (map_switch_details) {
    switch(GetCurrentMap()) {
      case ("beach.rmp"): filename = "beach hut.rmp"; break;
      case ("treehouse.rmp"): filename = "forest path.rmp"; break;
      case ("graveyard.rmp"): filename = "beach.rmp"; break;
      case ("church inside front.rmp"): filename = "church inside back.rmp"; break;
      case ("cave.rmp"): filename = "treehouse.rmp"; break;
    }


    MapSwitch(loop_horizontally, loop_vertically, block_horizontally, block_vertically, filename, person, x, y)
  }
}

function OnLeaveMapSouth() {
  var map_switch_details = GetMapSwitchDetails("south");

  with (map_switch_details) {
    switch(GetCurrentMap()) {
      case ("forest path.rmp"): filename = "beach.rmp"; break;
      case ("forest house.rmp"): filename = "forest path.rmp"; break;
      case ("treehouse.rmp"): filename = "graveyard.rmp"; break;
      case ("church.rmp"): filename = "cave inside.rmp"; break;
      case ("church inside front.rmp"): filename = "church.rmp"; break;
      case ("cave inside.rmp"): filename = "cave.rmp"; break;
    }

    MapSwitch(loop_horizontally, loop_vertically, block_horizontally, block_vertically, filename, person, x, y)
  }
}

function OnLeaveMapWest() {
  var map_switch_details = GetMapSwitchDetails("west");

  with (map_switch_details) {
    switch(GetCurrentMap()) {
      case ("beach hut.rmp"): filename = "beach.rmp"; break;
      case ("forest path.rmp"): filename = "treehouse.rmp"; break;
      case ("beach.rmp"): filename = "graveyard.rmp"; break;
      case ("church inside back.rmp"): filename = "church inside front.rmp"; break;
      case ("treehouse.rmp"): filename = "cave.rmp"; break;
    }

    MapSwitch(loop_horizontally, loop_vertically, block_horizontally, block_vertically, filename, person, x, y)
  }
}


//////////////////////////////////////

function GetMapWidth() {
  var v = 0;
  for (var i = 0; i < GetNumLayers(); ++i)
    v = Math.max(GetLayerWidth(i) * GetTileWidth(), v);
  return v;
}

function GetMapHeight() {
  var v = 0;
  for (var i = 0; i < GetNumLayers(); ++i)
    v = Math.max(GetLayerHeight(i) * GetTileHeight(), v);
  return v;
}

/////////////////////////////////////

function Warp(x, y, layer, map) {
  if (map) ChangeMap(map);
  if (IsInputAttached()) {
    var person = GetInputPerson();
    if (layer) SetPersonLayer(person, layer);
    if (x) SetPersonX(person, x);
    if (y) SetPersonY(person, y);
  }
}